// qadrng.h: Quick and Dirty RNG
// Requires 32-bit ints, and IEEE float
#ifndef QADRNG_H
#define QADRNG_H

inline   
int randum() {
   static idum = 0;
   idum = idum*1664525 + 1013904223;
   return idum;
}

inline
float randumf() {
   int temp = randum();
   temp = 0x3f800000 | (0x007fffff & temp);
   return *static_cast<float*>(&temp) - 1.0f;
}

#endif

