#include <cmath>
#include <iostream>
#include <limits>
#include "ulps2.h"
using namespace std;

int main() {
   cout.precision(numeric_limits<float>::digits10 - 1);
/*   cout << ulps(-1.0f, -1.0000001f) << endl;
   cout << ulps(1.0f, 1.0000001f) << endl;
   cout << ulps(1.0f, 1.0000002f) << endl;
   cout << ulps(1.0f, 1.0000003f) << endl;
   cout << ulps(1.0f, 1.0000004f) << endl;
   cout << ulps(0.99999995f, 1.0f) << endl;*/
   cout << ulps(0.4999995f, 2.0f) << endl;
   cout << ulps(0.5000005f, 2.0f) << endl;
   cout << ulps(0.5f, 2.0f) << endl;
/*   cout << ulps(1.0f, 2.0f) << endl;
   cout << pow(2.0f, 23.0f) << endl << endl;*/

   cout.precision(numeric_limits<double>::digits10 - 1);
/*   cout << ulps(-1.0, -1.0000000000000003) << endl;
   cout << ulps(1.0, 1.0000000000000003) << endl;
   cout << ulps(1.0, 1.0000000000000004) << endl;
   cout << ulps(1.0, 1.0000000000000005) << endl;
   cout << ulps(1.0, 1.0000000000000006) << endl;
   cout << ulps(0.9999999999999999, 1.0) << endl;*/
   cout << ulps(0.4999999999999995, 2.0) << endl;
   cout << ulps(0.5000000000000005, 2.0) << endl;
   cout << ulps(0.5, 2.0) << endl;
/*   cout << ulps(1.0, 2.0) << endl;
   cout << pow(2.0, 52) << endl;
   cout << ulps(-1.0, 1.0) << endl;
   cout << ulps(-1.0, 0.0) << endl;
   cout << ulps(0.0, 1.0) << endl;*/
}

/* Output:
1
1
2
3
3
1
8.38861e+06
8.38861e+06

1
1
2
2
3
1
4.5036e+15
4.5036e+15
inf
inf
inf
*/
