#include <cfloat>
#include <cmath>
#include <iostream>
using namespace std;

int main() {
   cout.precision(LDBL_DIG);
   cout.setf(ios::showpoint);
   cout.setf(ios::scientific);
   long double a = 1.0L;
   long double b = -1.0e5L;
   long double c = 1.0L;

   // Make a = 1
   b = b / a;
   c = c / a;
   long double d = (long double)b*b -4.0L*c;   // Use max precision
   if (d >= 0) {
      // Real roots
      long double e = sqrt(d);
      long double r1 = (-b - e) / 2.0L;
      long double r2 = (-b + e) / 2.0L;
      cout << "r1 = " << r1 << ", r2 = " << r2 << endl;
   }
   else {
      // Compex roots
      long double p = -b / 2.0L;
      long double q = sqrt(-d) / 2.0L;
      cout << "r1 = " << p << " + " << q << "i\n";
      cout << "r2 = " << p << " + " << q << "i\n";
   }
}

